{% set mapping_index = item[0] %}
{% set mapping = item[1] %}

{% set rule_id = 10000 + mapping_index %}
{% set max_score = 5 %}

{% for prop in ["default_sec_profile", "has a security profile"] %}
  {% set sec_profile = mapping[prop] %}
  {% if sec_profile is sequence and sec_profile is not string and sec_profile|length == 1 %}
    {% set max_score = sec_profile[0]["has a maximum anomaly score"] %}
  {% endif %}
{% endfor %}

SecDefaultAction "phase:2,pass,nolog,tag:'UID:{{ mapping["uid"] }}'"
SecAction "id:{{ rule_id }},phase:1,nolog,pass,t:none,setvar:'tx.inbound_anomaly_score_threshold={{ max_score }}'"

{% for prop in ["default_sec_profile", "has a security profile"] %}
  {% set sec_profile = mapping[prop] %}
  {% if sec_profile is sequence and sec_profile is not string and sec_profile|length == 1 %}
    {% set exc_list = sec_profile[0].get("has as exceptions") %}
    {% if exc_list is sequence and exc_list is not string %}
      ##### EXCEPTIONS #####

      {% for exc in exc_list %}
        {% set exc_uid  = exc["uid"] %}
        {% set exc_type = exc["has a type"] %}
        {% set exc_val  = exc["has a value"] %}

        # EXCEPTION UID {{ exc_uid }}
        {% if exc_type == "IP_BLACKLIST" %}
          SecRule REMOTE_ADDR \
            "@ipMatch {{ exc_value }}" \
            "id:{{ rule_id }},phase:1,t:none,nolog,deny"
        {% elif exc_type == "IP_WHITELIST" %}
          SecRule REMOTE_ADDR \
            "@ipMatch {{ exc_value }}" \
            "id:{{ rule_id }},phase:1,t:none,nolog,pass,ctl:ruleEngine=off"
        {% elif exc_type == "URL_BLACKLIST" %}
          SecRule REQUEST_URI \
            "{{ exc_value }}" \
            "id:{{ rule_id }},phase:1,t:none,nolog,deny"
        {% elif exc_type == "URL_WHITELIST" %}
          SecRule REQUEST_URI \
            "{{ exc_value }}" \
            "id:{{ rule_id }},phase:1,t:none,nolog,pass,ctl:ruleEngine=off"
        {% else %}
          # Unknown exception type: {{ exc_type }}
        {% endif %}
      {% endfor %}
    {% endif %}

    {% set custom_list = sec_profile[0].get("has as CPL complex code") %}
    {% if custom_list is sequence and custom_list is not string %}
      {% for custom in custom_list|sort(attribute="has a priority") %}
        # {{ custom["uid"] }} - {{ custom["has a name"] }}
        {{ custom["has as configuration mapping"] | replace("###RULE_ID###", str(rule_id)) | replace("###MAPUID###", mapping["uid"]) | replace("###MAX_SCORE###", str(max_score)) }}
      {% endfor %}
    {% endif %}
  {% endif %}
{% endfor %}
